<?php

/**
 *  Display for the attachments
 */
function media_attach_node_display($node, $options = array()) {
  $items = _media_attach_node_select($node, 'visible', $options);
  if (count($items)) {
    return theme('media_attach_visible', $items);
  }
  return '';
}

/**
 *  The links section for attached media
 */
function media_attach_node_links($node, $options = array()) {
  $items = _media_attach_node_select($node, 'link', $options);
  if (count($items)) {
    return theme('media_attach_link', $items);
  }
  return array();
}

/**
 *  The playlist for the attached media
 */
function media_attach_node_playlist($node, $options = array()) {
  $items = _media_attach_node_select($node, 'playlist', $options);
  return $items;
}

/**
 *  The defaults for the attached media, allows for specific things
 *  to be checked for.
 */
function media_attach_node_defaults($node, $options = array()) {
  $items = _media_attach_node_select($node, 'default_show', $options);
  // if no default options, use the visible ones
  if (!count($items)) {
    $items = _media_attach_node_select($node, 'visible', $options);
  }
  return $items;
}
