<?php

/**
 *  Invokes hook_media_attach()
 */
function media_attach_invoke($op, &$items = null, $data = null) {
  $return = array();
  foreach (module_implements('media_attach') as $name) {
    $function = $name .'_media_attach';
    $result = $function($op, $items, $data);
    // otherwise just return results
    if (isset($result) && is_array($result)) {
      $return = array_merge($return, $result);
    }
    else if (isset($result)) {
      $return[] = $result;
    }
  }
  ksort($return);
  return $return;
}