<?php

/**
 *  Implementation of hook_media_attach()
 */
function mapi_image_media_attach($op, &$item, $data) {
  if ($op == 'embed') {
    return array(
      'image' => array('_mapi_image_media_attach_image', $data, $item),
    );
  }
  elseif ($op == 'embed info') {
    return array(
      'image' => t('Should contain details such as'),
    );
  }
}

function _mapi_image_media_attach_image($list, $node, $context) {
  $attached = media_attach_node_defaults($node, array('type' => 'image'));

  // extract settings from list
  $items = (isset($list[0]) ? $list[0] : array());
  $settings = (isset($list[1]) ? $list[1] : array());

  // get the first of the list, if there is nothing already selected
  if (($image = array_shift($items)) && array_key_exists($image, $attached)) {
    $image = $attached[$image];
  }
  else {
    $image = array_shift($attached);
  }

  if (!empty($image)) {
    $filename = $image['filename'];

    // check if we can use the layouting module
    $layout = (isset($settings['layout']) ? $settings['layout'] : '');
    if (module_exists('mapi_layout') && $layout && in_array($layout, mapi_layout_list())) {
      // load the metadata and add necessary outlets
      $meta = media_metadata_load($image['mid']);
      $meta['caption'] = $image['caption'];
      $meta['filename'] = $image['filename'];
      $meta['content'] = mapi_display($filename, array('context' => $context));
      $meta['context'] = $context;
      $meta['settings'] = $settings;

      // run it through the layout generator
      $display = mapi_layout_generate($layout, $meta);
    }
    else {
      $display = mapi_display($filename, array('context' => $context));
    }

    return $display;
  }
}
