<?php

/**
 *  Implementation of hook_media_attach()
 */
function mapi_slideshow_media_attach($op, &$item, $data) {
  if ($op == 'embed') {
    return array(
      'slideshow' => array('_mapi_slideshow_media_attach_slideshow', $data, $item),
    );
  }
  elseif ($op == 'embed info') {
    return array(
      'slideshow' => t('Shows slideshow of images.'),
    );
  }
}

function _mapi_slideshow_media_attach_slideshow($list, $node, $context) {
  $attached = media_attach_node_playlist($node, array('type' => 'image'));

  // extract settings from list
  $items = (isset($list[0]) ? $list[0] : array());
  $settings = (isset($list[1]) ? $list[1] : array());

  // remove all items that are NOT in the list, otherwise all are displayed
  if (!empty($items)) {
    foreach (array_keys($attached) as $key) {
      if (!in_array($key, $items)) {
        unset($attached[$key]);
      }
    }
  }

  // no playlist of movies, return nothing
  if (!count($attached)) {
    return '';
  }

  // change the name into the actual filename to be displayed
  foreach ($attached as $key => $value) {
    $attached[$key]['filename'] = mapi_filename($value['filename'], $context);
  }

  $first = $attached[0]['filename'];
  if (!isset($settings['height']) || !isset($settings['width'])) {
    $dim = mapi_file_dimensions($first);
    // we want to keep the general aspect ratio here
    if (isset($dim['height']) && $dim['height'] && isset($dim['width']) && $dim['width']) {
      if (!isset($settings['height']) && !isset($settings['width'])) {
        $settings['height'] = $dim['height'];
        $settings['width'] = $dim['width'];
      }
      elseif (!isset($settings['height'])) {
        $settings['height'] = ($dim['height']/$dim['width']) * $settings['width'];
      }
      else {
        $settings['width'] = ($dim['width']/$dim['height']) * $settings['height'];
      }
    }
  }

  return mapi_slideshow_generate('node-'. $node->nid, (isset($settings['layout']) ? $settings['layout'] : 'generic'), $attached, $settings);
}
